busybox/scripts/trylink
<<
>>
Prefs
   1#!/bin/sh
   2
   3debug=false
   4
   5# Linker flags used:
   6#
   7# Informational:
   8# --warn-common
   9# -Map $EXE.map
  10# --verbose
  11#
  12# Optimizations:
  13# --sort-common                 reduces padding
  14# --sort-section alignment      reduces padding
  15# --gc-sections                 throws out unused sections,
  16#                               does not work for shared libs
  17# -On                           Not used, maybe useful?
  18#
  19# List of files to link:
  20# $l_list                       == --start-group -llib1 -llib2 --end-group
  21# --start-group $O_FILES $A_FILES --end-group
  22#
  23# Shared library link:
  24# -shared                       self-explanatory
  25# -fPIC                         position-independent code
  26# --enable-new-dtags            ?
  27# -z,combreloc                  ?
  28# -soname="libbusybox.so.$BB_VER"
  29# --undefined=lbb_main          Seed name to start pulling from
  30#                               (otherwise we'll need --whole-archive)
  31# -static                       Not used, but may be useful! manpage:
  32#                               "... This option can be used with -shared.
  33#                               Doing so means that a shared library
  34#                               is being created but that all of the library's
  35#                               external references must be resolved by pulling
  36#                               in entries from static libraries."
  37
  38
  39try() {
  40    printf "%s\n" "Output of:" >$EXE.out
  41    printf "%s\n" "$*" >>$EXE.out
  42    printf "%s\n" "==========" >>$EXE.out
  43    $debug && echo "Trying: $*"
  44    $@ >>$EXE.out 2>&1
  45    return $?
  46}
  47
  48check_cc() {
  49    tempname="$(mktemp tmp.XXXXXXXXXX)"
  50    echo "int main(int argc,char**argv){return argv?argc:0;}" >"$tempname".c
  51    # Can use "-o /dev/null", but older gcc tend to *unlink it* on failure! :(
  52    # Was using "-xc /dev/null", but we need a valid C program.
  53    # "eval" may be needed if CFLAGS can contain
  54    # '... -D"BB_VER=KBUILD_STR(1.N.M)" ...'
  55    # and we need shell to process quotes!
  56    $CC $CFLAGS $LDFLAGS $1 "$tempname".c -o "$tempname" >/dev/null 2>&1
  57    exitcode=$?
  58    rm -f "$tempname" "$tempname".c "$tempname".o
  59    return $exitcode
  60}
  61
  62check_libc_is_glibc() {
  63    tempname="$(mktemp tmp.XXXXXXXXXX)"
  64    echo "\
  65        #include <stdlib.h>
  66        /* Apparently uclibc defines __GLIBC__ (compat trick?). Oh well. */
  67        #if defined(__GLIBC__) && !defined(__UCLIBC__)
  68        syntax error here
  69        #endif
  70        " >"$tempname".c
  71    ! $CC $CFLAGS "$tempname".c -c -o "$tempname".o >/dev/null 2>&1
  72    exitcode=$?
  73    rm -f "$tempname" "$tempname".c "$tempname".o
  74    return $exitcode
  75}
  76
  77EXE="$1"
  78CC="$2"
  79CFLAGS="$3"
  80LDFLAGS="$4"
  81O_FILES="$5"
  82A_FILES="$6"
  83LDLIBS="$7"
  84
  85# The --sort-section option is not supported by older versions of ld
  86SORT_SECTION="-Wl,--sort-section,alignment"
  87if ! check_cc "-Wl,--sort-section,alignment"; then
  88    echo "Your linker does not support --sort-section,alignment"
  89    SORT_SECTION=""
  90fi
  91
  92START_GROUP="-Wl,--start-group"
  93END_GROUP="-Wl,--end-group"
  94INFO_OPTS() {
  95        echo "-Wl,--warn-common -Wl,-Map,$EXE.map -Wl,--verbose"
  96}
  97
  98# gold may not support --sort-common (yet)
  99SORT_COMMON="-Wl,--sort-common"
 100if ! check_cc "-Wl,--sort-common"; then
 101    echo "Your linker does not support --sort-common"
 102    SORT_COMMON=""
 103fi
 104
 105# Static linking against glibc produces buggy executables
 106# (glibc does not cope well with ld --gc-sections).
 107# See sources.redhat.com/bugzilla/show_bug.cgi?id=3400
 108# Note that glibc is unsuitable for static linking anyway.
 109# We are removing -Wl,--gc-sections from link command line.
 110GC_SECTIONS="-Wl,--gc-sections"
 111if (. ./.config && test x"$CONFIG_STATIC" = x"y") then
 112    if check_libc_is_glibc; then
 113        echo "Static linking against glibc, can't use --gc-sections"
 114        GC_SECTIONS=""
 115    fi
 116fi
 117# The --gc-sections option is not supported by older versions of ld
 118if test -n "$GC_SECTIONS"; then
 119    if ! check_cc "$GC_SECTIONS"; then
 120        echo "Your linker does not support $GC_SECTIONS"
 121        GC_SECTIONS=""
 122    fi
 123fi
 124
 125# Sanitize lib list (dups, extra spaces etc)
 126LDLIBS=`echo "$LDLIBS" | xargs -n1 | sort | uniq | xargs`
 127
 128# First link with all libs. If it fails, bail out
 129echo "Trying libraries: $LDLIBS"
 130# "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
 131l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
 132test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
 133try $CC $CFLAGS $LDFLAGS \
 134        -o $EXE \
 135        $SORT_COMMON \
 136        $SORT_SECTION \
 137        $GC_SECTIONS \
 138        $START_GROUP $O_FILES $A_FILES $END_GROUP \
 139        $l_list \
 140|| {
 141    echo "Failed: $l_list"
 142    cat $EXE.out
 143    echo 'Note: if build needs additional libraries, put them in CONFIG_EXTRA_LDLIBS.'
 144    echo 'Example: CONFIG_EXTRA_LDLIBS="pthread dl tirpc audit pam"'
 145    exit 1
 146}
 147
 148# Now try to remove each lib and build without it.
 149# Stop when no lib can be removed.
 150while test "$LDLIBS"; do
 151    $debug && echo "Trying libraries: $LDLIBS"
 152    dropped_non_first_lib=false
 153    first_lib=true
 154    for one in $LDLIBS; do
 155        without_one=`echo " $LDLIBS " | sed "s/ $one / /g" | xargs`
 156        # "lib1 lib2 lib3" -> "-llib1 -llib2 -llib3"
 157        l_list=`echo " $without_one " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
 158        test x"$l_list" != x"" && l_list="$START_GROUP $l_list $END_GROUP"
 159        $debug && echo "Trying -l options: '$l_list'"
 160        try $CC $CFLAGS $LDFLAGS \
 161                -o $EXE \
 162                $SORT_COMMON \
 163                $SORT_SECTION \
 164                $GC_SECTIONS \
 165                $START_GROUP $O_FILES $A_FILES $END_GROUP \
 166                $l_list
 167        if test $? = 0; then
 168            echo " Library $one is not needed, excluding it"
 169            LDLIBS="$without_one"
 170            $first_lib || dropped_non_first_lib=true
 171        else
 172            echo " Library $one is needed, can't exclude it (yet)"
 173            first_lib=false
 174        fi
 175    done
 176    # We can stop trying to drop libs if either all libs were needed,
 177    # or we excluded only the _first_ few.
 178    # (else: we dropped some intermediate lib(s), maybe now we can succeed
 179    # in dropping some of the preceding ones)
 180    $dropped_non_first_lib || break
 181done
 182
 183# Make the binary with final, minimal list of libs
 184echo "Final link with: ${LDLIBS:-<none>}"
 185l_list=`echo " $LDLIBS " | sed -e 's: \([^- ][^ ]*\): -l\1:g'`
 186test "x$l_list" != "x" && l_list="$START_GROUP $l_list $END_GROUP"
 187# --verbose gives us gobs of info to stdout (e.g. linker script used)
 188if ! test -f busybox_ldscript; then
 189    try $CC $CFLAGS $LDFLAGS \
 190            -o $EXE \
 191            $SORT_COMMON \
 192            $SORT_SECTION \
 193            $GC_SECTIONS \
 194            $START_GROUP $O_FILES $A_FILES $END_GROUP \
 195            $l_list \
 196            `INFO_OPTS` \
 197    || {
 198        cat $EXE.out
 199        exit 1
 200    }
 201else
 202    echo "Custom linker script 'busybox_ldscript' found, using it"
 203    # Add SORT_BY_ALIGNMENT to linker script (found in $EXE.out):
 204    #  .rodata         : { *(.rodata SORT_BY_ALIGNMENT(.rodata.*) .gnu.linkonce.r.*) }
 205    #  *(.data SORT_BY_ALIGNMENT(.data.*) .gnu.linkonce.d.*)
 206    #  *(.bss SORT_BY_ALIGNMENT(.bss.*) .gnu.linkonce.b.*)
 207    # This will eliminate most of the padding (~3kb).
 208    # Hmm, "ld --sort-section alignment" should do it too.
 209    #
 210    # There is a ld hack which is meant to decrease disk usage
 211    # at the cost of more RAM usage (??!!) in standard ld script:
 212    #  /* Adjust the address for the data segment.  We want to adjust up to
 213    #     the same address within the page on the next page up.  */
 214    #  . = ALIGN (0x1000) - ((0x1000 - .) & (0x1000 - 1)); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
 215    # Replace it with:
 216    #  . = ALIGN (0x1000); . = DATA_SEGMENT_ALIGN (0x1000, 0x1000);
 217    # to unconditionally align .data to the next page boundary,
 218    # instead of "next page, plus current offset in this page"
 219    try $CC $CFLAGS $LDFLAGS \
 220            -o $EXE \
 221            $SORT_COMMON \
 222            $SORT_SECTION \
 223            $GC_SECTIONS \
 224            -Wl,-T,busybox_ldscript \
 225            $START_GROUP $O_FILES $A_FILES $END_GROUP \
 226            $l_list \
 227            `INFO_OPTS` \
 228    || {
 229        cat $EXE.out
 230        exit 1
 231    }
 232fi
 233
 234. ./.config
 235
 236sharedlib_dir="0_lib"
 237
 238if test "$CONFIG_BUILD_LIBBUSYBOX" = y; then
 239    mkdir "$sharedlib_dir" 2>/dev/null
 240    test -d "$sharedlib_dir" || {
 241        echo "Cannot make directory $sharedlib_dir"
 242        exit 1
 243    }
 244    ln -s "libbusybox.so.$BB_VER" "$sharedlib_dir"/libbusybox.so 2>/dev/null
 245
 246    # Yes, "ld -shared -static" is a thing. It's a shared library which is itself static.
 247    LBB_STATIC=""
 248    test "$CONFIG_FEATURE_LIBBUSYBOX_STATIC" = y && LBB_STATIC="-Wl,-static"
 249
 250    EXE="$sharedlib_dir/libbusybox.so.${BB_VER}_unstripped"
 251    try $CC $CFLAGS $LDFLAGS \
 252            -o $EXE \
 253            -shared -fPIC $LBB_STATIC \
 254            -Wl,--enable-new-dtags \
 255            -Wl,-z,combreloc \
 256            -Wl,-soname="libbusybox.so.$BB_VER" \
 257            -Wl,--undefined=lbb_main \
 258            $SORT_COMMON \
 259            $SORT_SECTION \
 260            $START_GROUP $A_FILES $END_GROUP \
 261            $l_list \
 262            `INFO_OPTS` \
 263    || {
 264        echo "Linking $EXE failed"
 265        cat $EXE.out
 266        exit 1
 267    }
 268    $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/libbusybox.so.$BB_VER"
 269    chmod a+x "$sharedlib_dir/libbusybox.so.$BB_VER"
 270    echo "libbusybox: $sharedlib_dir/libbusybox.so.$BB_VER"
 271fi
 272
 273if test "$CONFIG_FEATURE_SHARED_BUSYBOX" = y; then
 274    EXE="$sharedlib_dir/busybox_unstripped"
 275    try $CC $CFLAGS $LDFLAGS \
 276            -o $EXE \
 277            $SORT_COMMON \
 278            $SORT_SECTION \
 279            $GC_SECTIONS \
 280            $START_GROUP $O_FILES $END_GROUP \
 281            -L"$sharedlib_dir" -lbusybox \
 282            $l_list \
 283            `INFO_OPTS` \
 284    || {
 285        echo "Linking $EXE failed"
 286        cat $EXE.out
 287        exit 1
 288    }
 289    $STRIP -s --remove-section=.note --remove-section=.comment $EXE -o "$sharedlib_dir/busybox"
 290    echo "busybox linked against libbusybox: $sharedlib_dir/busybox"
 291fi
 292
 293if test "$CONFIG_FEATURE_INDIVIDUAL" = y; then
 294    echo "Linking individual applets against libbusybox (see $sharedlib_dir/*)"
 295    gcc -DNAME_MAIN -E -include include/autoconf.h include/applets.h \
 296    | grep -v "^#" \
 297    | grep -v "^ *$" \
 298    > applet_lst.tmp
 299    while read name main junk; do
 300
 301        echo "\
 302void lbb_prepare(const char *applet, char **argv);
 303int $main(int argc, char **argv);
 304
 305int main(int argc, char **argv)
 306{
 307        lbb_prepare(\"$name\", argv);
 308        return $main(argc, argv);
 309}
 310" >"$sharedlib_dir/applet.c"
 311
 312        EXE="$sharedlib_dir/$name"
 313        try $CC $CFLAGS $LDFLAGS "$sharedlib_dir/applet.c" \
 314                -o $EXE \
 315                $SORT_COMMON \
 316                $SORT_SECTION \
 317                $GC_SECTIONS \
 318                -L"$sharedlib_dir" -lbusybox \
 319                -Wl,--warn-common \
 320        || {
 321            echo "Linking $EXE failed"
 322            cat $EXE.out
 323            exit 1
 324        }
 325        rm -- "$sharedlib_dir/applet.c" $EXE.out
 326        $STRIP -s --remove-section=.note --remove-section=.comment $EXE
 327        # Let user see that we do something - list the names of created binaries:
 328        echo "$EXE"
 329
 330    done <applet_lst.tmp
 331fi
 332
 333# libbusybox.so is needed only for -lbusybox at link time,
 334# it is not needed at runtime. Deleting to reduce confusion.
 335rm "$sharedlib_dir"/libbusybox.so 2>/dev/null
 336exit 0 # or else we may confuse make
 337